/*
 * Licensed Materials - Property of IBM
 *
 * com.ibm.etools.c
 *
 *  Copyright IBM Corporation 2004. All Rights Reserved. 
 *
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */
package com.ibm.etools.c.datatypes;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc --> The <b>Factory </b> for the model. It provides a
 * create method for each non-abstract class of the model. <!-- end-user-doc -->
 * 
 * @see com.ibm.etools.c.datatypes.DatatypesPackage
 * @generated
 */
public interface DatatypesFactory extends EFactory {
    /**
     * The singleton instance of the factory. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    DatatypesFactory eINSTANCE = new com.ibm.etools.c.datatypes.impl.DatatypesFactoryImpl();

    /**
     * Returns a new object of class '<em>CLong Double</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>CLong Double</em>'.
     * @generated
     */
    CLongDouble createCLongDouble();

    /**
     * Returns a new object of class '<em>CFloat</em>'. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>CFloat</em>'.
     * @generated
     */
    CFloat createCFloat();

    /**
     * Returns a new object of class '<em>CUnsigned Short</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>CUnsigned Short</em>'.
     * @generated
     */
    CUnsignedShort createCUnsignedShort();

    /**
     * Returns a new object of class '<em>CDouble</em>'. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>CDouble</em>'.
     * @generated
     */
    CDouble createCDouble();

    /**
     * Returns a new object of class '<em>CShort</em>'. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>CShort</em>'.
     * @generated
     */
    CShort createCShort();

    /**
     * Returns a new object of class '<em>CUnsigned Long Long</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>CUnsigned Long Long</em>'.
     * @generated
     */
    CUnsignedLongLong createCUnsignedLongLong();

    /**
     * Returns a new object of class '<em>CLong Long</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>CLong Long</em>'.
     * @generated
     */
    CLongLong createCLongLong();

    /**
     * Returns a new object of class '<em>CUnsigned Long</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>CUnsigned Long</em>'.
     * @generated
     */
    CUnsignedLong createCUnsignedLong();

    /**
     * Returns a new object of class '<em>CLong</em>'. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>CLong</em>'.
     * @generated
     */
    CLong createCLong();

    /**
     * Returns a new object of class '<em>CUnsigned Char</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>CUnsigned Char</em>'.
     * @generated
     */
    CUnsignedChar createCUnsignedChar();

    /**
     * Returns a new object of class '<em>CChar</em>'. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>CChar</em>'.
     * @generated
     */
    CChar createCChar();

    /**
     * Returns a new object of class '<em>CVoid</em>'. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>CVoid</em>'.
     * @generated
     */
    CVoid createCVoid();

    /**
     * Returns a new object of class '<em>CWchar</em>'. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>CWchar</em>'.
     * @generated
     */
    CWchar createCWchar();

    /**
     * Returns a new object of class '<em>CInt</em>'. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>CInt</em>'.
     * @generated
     */
    CInt createCInt();

    /**
     * Returns a new object of class '<em>CUnsigned Int</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>CUnsigned Int</em>'.
     * @generated
     */
    CUnsignedInt createCUnsignedInt();

    /**
     * Returns a new object of class '<em>CBit Field</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>CBit Field</em>'.
     * @generated
     */
    CBitField createCBitField();

    /**
     * Returns a new object of class '<em>CSigned Char</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>CSigned Char</em>'.
     * @generated
     */
    CSignedChar createCSignedChar();

    /**
     * Returns a new object of class '<em>CEnumeration</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>CEnumeration</em>'.
     * @generated
     */
    CEnumeration createCEnumeration();

    /**
     * Returns the package supported by this factory. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the package supported by this factory.
     * @generated
     */
    DatatypesPackage getDatatypesPackage();

} //DatatypesFactory
