/*
 * Licensed Materials - Property of IBM
 *
 * com.ibm.etools.c
 *
 *  Copyright IBM Corporation 2004. All Rights Reserved. 
 *
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */
package com.ibm.etools.c.datatypes;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import com.ibm.etools.c.CPackage;

/**
 * <!-- begin-user-doc --> The <b>Package </b> for the model. It contains
 * accessors for the meta objects to represent
 * <ul>
 * <li>each class,</li>
 * <li>each feature of each class,</li>
 * <li>each enum,</li>
 * <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * 
 * @see com.ibm.etools.c.datatypes.DatatypesFactory
 * @generated
 */
public interface DatatypesPackage extends EPackage {
    /**
     * The package name. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    String eNAME = "datatypes";

    /**
     * The package namespace URI. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    String eNS_URI = "http:///c/datatypes.ecore";

    /**
     * The package namespace name. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    String eNS_PREFIX = "c.datatypes";

    /**
     * The singleton instance of the package. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    DatatypesPackage eINSTANCE = com.ibm.etools.c.datatypes.impl.DatatypesPackageImpl.init();

    /**
     * The meta object id for the '
     * {@link com.ibm.etools.c.datatypes.impl.CFloatingImpl <em>CFloating</em>}'
     * class. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see com.ibm.etools.c.datatypes.impl.CFloatingImpl
     * @see com.ibm.etools.c.datatypes.impl.DatatypesPackageImpl#getCFloating()
     * @generated
     */
    int CFLOATING = 1;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CFLOATING__NAME = CPackage.CDATATYPE__NAME;

    /**
     * The feature id for the '<em><b>Td Lang Typed Element</b></em>'
     * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CFLOATING__TD_LANG_TYPED_ELEMENT = CPackage.CDATATYPE__TD_LANG_TYPED_ELEMENT;

    /**
     * The number of structural features of the the '<em>CFloating</em>'
     * class. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CFLOATING_FEATURE_COUNT = CPackage.CDATATYPE_FEATURE_COUNT + 0;

    /**
     * The meta object id for the '
     * {@link com.ibm.etools.c.datatypes.impl.CLongDoubleImpl <em>CLong Double</em>}'
     * class. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see com.ibm.etools.c.datatypes.impl.CLongDoubleImpl
     * @see com.ibm.etools.c.datatypes.impl.DatatypesPackageImpl#getCLongDouble()
     * @generated
     */
    int CLONG_DOUBLE = 0;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CLONG_DOUBLE__NAME = CFLOATING__NAME;

    /**
     * The feature id for the '<em><b>Td Lang Typed Element</b></em>'
     * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CLONG_DOUBLE__TD_LANG_TYPED_ELEMENT = CFLOATING__TD_LANG_TYPED_ELEMENT;

    /**
     * The number of structural features of the the '<em>CLong Double</em>'
     * class. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CLONG_DOUBLE_FEATURE_COUNT = CFLOATING_FEATURE_COUNT + 0;

    /**
     * The meta object id for the '
     * {@link com.ibm.etools.c.datatypes.impl.CFloatImpl <em>CFloat</em>}'
     * class. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see com.ibm.etools.c.datatypes.impl.CFloatImpl
     * @see com.ibm.etools.c.datatypes.impl.DatatypesPackageImpl#getCFloat()
     * @generated
     */
    int CFLOAT = 2;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CFLOAT__NAME = CFLOATING__NAME;

    /**
     * The feature id for the '<em><b>Td Lang Typed Element</b></em>'
     * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CFLOAT__TD_LANG_TYPED_ELEMENT = CFLOATING__TD_LANG_TYPED_ELEMENT;

    /**
     * The number of structural features of the the '<em>CFloat</em>' class.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CFLOAT_FEATURE_COUNT = CFLOATING_FEATURE_COUNT + 0;

    /**
     * The meta object id for the '
     * {@link com.ibm.etools.c.datatypes.impl.CIntegralImpl <em>CIntegral</em>}'
     * class. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see com.ibm.etools.c.datatypes.impl.CIntegralImpl
     * @see com.ibm.etools.c.datatypes.impl.DatatypesPackageImpl#getCIntegral()
     * @generated
     */
    int CINTEGRAL = 9;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CINTEGRAL__NAME = CPackage.CDATATYPE__NAME;

    /**
     * The feature id for the '<em><b>Td Lang Typed Element</b></em>'
     * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CINTEGRAL__TD_LANG_TYPED_ELEMENT = CPackage.CDATATYPE__TD_LANG_TYPED_ELEMENT;

    /**
     * The number of structural features of the the '<em>CIntegral</em>'
     * class. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CINTEGRAL_FEATURE_COUNT = CPackage.CDATATYPE_FEATURE_COUNT + 0;

    /**
     * The meta object id for the '
     * {@link com.ibm.etools.c.datatypes.impl.CIntImpl <em>CInt</em>}' class.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see com.ibm.etools.c.datatypes.impl.CIntImpl
     * @see com.ibm.etools.c.datatypes.impl.DatatypesPackageImpl#getCInt()
     * @generated
     */
    int CINT = 15;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CINT__NAME = CINTEGRAL__NAME;

    /**
     * The feature id for the '<em><b>Td Lang Typed Element</b></em>'
     * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CINT__TD_LANG_TYPED_ELEMENT = CINTEGRAL__TD_LANG_TYPED_ELEMENT;

    /**
     * The number of structural features of the the '<em>CInt</em>' class.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CINT_FEATURE_COUNT = CINTEGRAL_FEATURE_COUNT + 0;

    /**
     * The meta object id for the '
     * {@link com.ibm.etools.c.datatypes.impl.CUnsignedIntImpl <em>CUnsigned Int</em>}'
     * class. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see com.ibm.etools.c.datatypes.impl.CUnsignedIntImpl
     * @see com.ibm.etools.c.datatypes.impl.DatatypesPackageImpl#getCUnsignedInt()
     * @generated
     */
    int CUNSIGNED_INT = 16;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CUNSIGNED_INT__NAME = CINT__NAME;

    /**
     * The feature id for the '<em><b>Td Lang Typed Element</b></em>'
     * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CUNSIGNED_INT__TD_LANG_TYPED_ELEMENT = CINT__TD_LANG_TYPED_ELEMENT;

    /**
     * The number of structural features of the the '<em>CUnsigned Int</em>'
     * class. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CUNSIGNED_INT_FEATURE_COUNT = CINT_FEATURE_COUNT + 0;

    /**
     * The meta object id for the '
     * {@link com.ibm.etools.c.datatypes.impl.CUnsignedShortImpl <em>CUnsigned Short</em>}'
     * class. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see com.ibm.etools.c.datatypes.impl.CUnsignedShortImpl
     * @see com.ibm.etools.c.datatypes.impl.DatatypesPackageImpl#getCUnsignedShort()
     * @generated
     */
    int CUNSIGNED_SHORT = 3;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CUNSIGNED_SHORT__NAME = CUNSIGNED_INT__NAME;

    /**
     * The feature id for the '<em><b>Td Lang Typed Element</b></em>'
     * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CUNSIGNED_SHORT__TD_LANG_TYPED_ELEMENT = CUNSIGNED_INT__TD_LANG_TYPED_ELEMENT;

    /**
     * The number of structural features of the the '<em>CUnsigned Short</em>'
     * class. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CUNSIGNED_SHORT_FEATURE_COUNT = CUNSIGNED_INT_FEATURE_COUNT + 0;

    /**
     * The meta object id for the '
     * {@link com.ibm.etools.c.datatypes.impl.CDoubleImpl <em>CDouble</em>}'
     * class. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see com.ibm.etools.c.datatypes.impl.CDoubleImpl
     * @see com.ibm.etools.c.datatypes.impl.DatatypesPackageImpl#getCDouble()
     * @generated
     */
    int CDOUBLE = 4;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CDOUBLE__NAME = CFLOATING__NAME;

    /**
     * The feature id for the '<em><b>Td Lang Typed Element</b></em>'
     * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CDOUBLE__TD_LANG_TYPED_ELEMENT = CFLOATING__TD_LANG_TYPED_ELEMENT;

    /**
     * The number of structural features of the the '<em>CDouble</em>'
     * class. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CDOUBLE_FEATURE_COUNT = CFLOATING_FEATURE_COUNT + 0;

    /**
     * The meta object id for the '
     * {@link com.ibm.etools.c.datatypes.impl.CShortImpl <em>CShort</em>}'
     * class. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see com.ibm.etools.c.datatypes.impl.CShortImpl
     * @see com.ibm.etools.c.datatypes.impl.DatatypesPackageImpl#getCShort()
     * @generated
     */
    int CSHORT = 5;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CSHORT__NAME = CINT__NAME;

    /**
     * The feature id for the '<em><b>Td Lang Typed Element</b></em>'
     * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CSHORT__TD_LANG_TYPED_ELEMENT = CINT__TD_LANG_TYPED_ELEMENT;

    /**
     * The number of structural features of the the '<em>CShort</em>' class.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CSHORT_FEATURE_COUNT = CINT_FEATURE_COUNT + 0;

    /**
     * The meta object id for the '
     * {@link com.ibm.etools.c.datatypes.impl.CUnsignedLongLongImpl <em>CUnsigned Long Long</em>}'
     * class. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see com.ibm.etools.c.datatypes.impl.CUnsignedLongLongImpl
     * @see com.ibm.etools.c.datatypes.impl.DatatypesPackageImpl#getCUnsignedLongLong()
     * @generated
     */
    int CUNSIGNED_LONG_LONG = 6;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CUNSIGNED_LONG_LONG__NAME = CUNSIGNED_INT__NAME;

    /**
     * The feature id for the '<em><b>Td Lang Typed Element</b></em>'
     * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CUNSIGNED_LONG_LONG__TD_LANG_TYPED_ELEMENT = CUNSIGNED_INT__TD_LANG_TYPED_ELEMENT;

    /**
     * The number of structural features of the the '
     * <em>CUnsigned Long Long</em>' class. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated @ordered
     */
    int CUNSIGNED_LONG_LONG_FEATURE_COUNT = CUNSIGNED_INT_FEATURE_COUNT + 0;

    /**
     * The meta object id for the '
     * {@link com.ibm.etools.c.datatypes.impl.CLongLongImpl <em>CLong Long</em>}'
     * class. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see com.ibm.etools.c.datatypes.impl.CLongLongImpl
     * @see com.ibm.etools.c.datatypes.impl.DatatypesPackageImpl#getCLongLong()
     * @generated
     */
    int CLONG_LONG = 7;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CLONG_LONG__NAME = CINT__NAME;

    /**
     * The feature id for the '<em><b>Td Lang Typed Element</b></em>'
     * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CLONG_LONG__TD_LANG_TYPED_ELEMENT = CINT__TD_LANG_TYPED_ELEMENT;

    /**
     * The number of structural features of the the '<em>CLong Long</em>'
     * class. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CLONG_LONG_FEATURE_COUNT = CINT_FEATURE_COUNT + 0;

    /**
     * The meta object id for the '
     * {@link com.ibm.etools.c.datatypes.impl.CUnsignedLongImpl <em>CUnsigned Long</em>}'
     * class. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see com.ibm.etools.c.datatypes.impl.CUnsignedLongImpl
     * @see com.ibm.etools.c.datatypes.impl.DatatypesPackageImpl#getCUnsignedLong()
     * @generated
     */
    int CUNSIGNED_LONG = 8;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CUNSIGNED_LONG__NAME = CUNSIGNED_INT__NAME;

    /**
     * The feature id for the '<em><b>Td Lang Typed Element</b></em>'
     * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CUNSIGNED_LONG__TD_LANG_TYPED_ELEMENT = CUNSIGNED_INT__TD_LANG_TYPED_ELEMENT;

    /**
     * The number of structural features of the the '<em>CUnsigned Long</em>'
     * class. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CUNSIGNED_LONG_FEATURE_COUNT = CUNSIGNED_INT_FEATURE_COUNT + 0;

    /**
     * The meta object id for the '
     * {@link com.ibm.etools.c.datatypes.impl.CLongImpl <em>CLong</em>}' class.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see com.ibm.etools.c.datatypes.impl.CLongImpl
     * @see com.ibm.etools.c.datatypes.impl.DatatypesPackageImpl#getCLong()
     * @generated
     */
    int CLONG = 10;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CLONG__NAME = CINT__NAME;

    /**
     * The feature id for the '<em><b>Td Lang Typed Element</b></em>'
     * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CLONG__TD_LANG_TYPED_ELEMENT = CINT__TD_LANG_TYPED_ELEMENT;

    /**
     * The number of structural features of the the '<em>CLong</em>' class.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CLONG_FEATURE_COUNT = CINT_FEATURE_COUNT + 0;

    /**
     * The meta object id for the '
     * {@link com.ibm.etools.c.datatypes.impl.CCharImpl <em>CChar</em>}' class.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see com.ibm.etools.c.datatypes.impl.CCharImpl
     * @see com.ibm.etools.c.datatypes.impl.DatatypesPackageImpl#getCChar()
     * @generated
     */
    int CCHAR = 12;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CCHAR__NAME = CINTEGRAL__NAME;

    /**
     * The feature id for the '<em><b>Td Lang Typed Element</b></em>'
     * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CCHAR__TD_LANG_TYPED_ELEMENT = CINTEGRAL__TD_LANG_TYPED_ELEMENT;

    /**
     * The number of structural features of the the '<em>CChar</em>' class.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CCHAR_FEATURE_COUNT = CINTEGRAL_FEATURE_COUNT + 0;

    /**
     * The meta object id for the '
     * {@link com.ibm.etools.c.datatypes.impl.CUnsignedCharImpl <em>CUnsigned Char</em>}'
     * class. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see com.ibm.etools.c.datatypes.impl.CUnsignedCharImpl
     * @see com.ibm.etools.c.datatypes.impl.DatatypesPackageImpl#getCUnsignedChar()
     * @generated
     */
    int CUNSIGNED_CHAR = 11;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CUNSIGNED_CHAR__NAME = CCHAR__NAME;

    /**
     * The feature id for the '<em><b>Td Lang Typed Element</b></em>'
     * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CUNSIGNED_CHAR__TD_LANG_TYPED_ELEMENT = CCHAR__TD_LANG_TYPED_ELEMENT;

    /**
     * The number of structural features of the the '<em>CUnsigned Char</em>'
     * class. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CUNSIGNED_CHAR_FEATURE_COUNT = CCHAR_FEATURE_COUNT + 0;

    /**
     * The meta object id for the '
     * {@link com.ibm.etools.c.datatypes.impl.CVoidImpl <em>CVoid</em>}' class.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see com.ibm.etools.c.datatypes.impl.CVoidImpl
     * @see com.ibm.etools.c.datatypes.impl.DatatypesPackageImpl#getCVoid()
     * @generated
     */
    int CVOID = 13;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CVOID__NAME = CPackage.CDATATYPE__NAME;

    /**
     * The feature id for the '<em><b>Td Lang Typed Element</b></em>'
     * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CVOID__TD_LANG_TYPED_ELEMENT = CPackage.CDATATYPE__TD_LANG_TYPED_ELEMENT;

    /**
     * The number of structural features of the the '<em>CVoid</em>' class.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CVOID_FEATURE_COUNT = CPackage.CDATATYPE_FEATURE_COUNT + 0;

    /**
     * The meta object id for the '
     * {@link com.ibm.etools.c.datatypes.impl.CWcharImpl <em>CWchar</em>}'
     * class. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see com.ibm.etools.c.datatypes.impl.CWcharImpl
     * @see com.ibm.etools.c.datatypes.impl.DatatypesPackageImpl#getCWchar()
     * @generated
     */
    int CWCHAR = 14;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CWCHAR__NAME = CCHAR__NAME;

    /**
     * The feature id for the '<em><b>Td Lang Typed Element</b></em>'
     * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CWCHAR__TD_LANG_TYPED_ELEMENT = CCHAR__TD_LANG_TYPED_ELEMENT;

    /**
     * The number of structural features of the the '<em>CWchar</em>' class.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CWCHAR_FEATURE_COUNT = CCHAR_FEATURE_COUNT + 0;

    /**
     * The meta object id for the '
     * {@link com.ibm.etools.c.datatypes.impl.CBitFieldImpl <em>CBit Field</em>}'
     * class. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see com.ibm.etools.c.datatypes.impl.CBitFieldImpl
     * @see com.ibm.etools.c.datatypes.impl.DatatypesPackageImpl#getCBitField()
     * @generated
     */
    int CBIT_FIELD = 17;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CBIT_FIELD__NAME = CPackage.CDATATYPE__NAME;

    /**
     * The feature id for the '<em><b>Td Lang Typed Element</b></em>'
     * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CBIT_FIELD__TD_LANG_TYPED_ELEMENT = CPackage.CDATATYPE__TD_LANG_TYPED_ELEMENT;

    /**
     * The feature id for the '<em><b>Size</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CBIT_FIELD__SIZE = CPackage.CDATATYPE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Base Type</b></em>' reference. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CBIT_FIELD__BASE_TYPE = CPackage.CDATATYPE_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the the '<em>CBit Field</em>'
     * class. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CBIT_FIELD_FEATURE_COUNT = CPackage.CDATATYPE_FEATURE_COUNT + 2;

    /**
     * The meta object id for the '
     * {@link com.ibm.etools.c.datatypes.impl.CSignedCharImpl <em>CSigned Char</em>}'
     * class. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see com.ibm.etools.c.datatypes.impl.CSignedCharImpl
     * @see com.ibm.etools.c.datatypes.impl.DatatypesPackageImpl#getCSignedChar()
     * @generated
     */
    int CSIGNED_CHAR = 18;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CSIGNED_CHAR__NAME = CCHAR__NAME;

    /**
     * The feature id for the '<em><b>Td Lang Typed Element</b></em>'
     * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CSIGNED_CHAR__TD_LANG_TYPED_ELEMENT = CCHAR__TD_LANG_TYPED_ELEMENT;

    /**
     * The number of structural features of the the '<em>CSigned Char</em>'
     * class. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CSIGNED_CHAR_FEATURE_COUNT = CCHAR_FEATURE_COUNT + 0;

    /**
     * The meta object id for the '
     * {@link com.ibm.etools.c.datatypes.impl.CEnumerationImpl <em>CEnumeration</em>}'
     * class. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see com.ibm.etools.c.datatypes.impl.CEnumerationImpl
     * @see com.ibm.etools.c.datatypes.impl.DatatypesPackageImpl#getCEnumeration()
     * @generated
     */
    int CENUMERATION = 19;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CENUMERATION__NAME = CINTEGRAL__NAME;

    /**
     * The feature id for the '<em><b>Td Lang Typed Element</b></em>'
     * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CENUMERATION__TD_LANG_TYPED_ELEMENT = CINTEGRAL__TD_LANG_TYPED_ELEMENT;

    /**
     * The feature id for the '<em><b>Enumerator</b></em>' containment
     * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CENUMERATION__ENUMERATOR = CINTEGRAL_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the the '<em>CEnumeration</em>'
     * class. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated @ordered
     */
    int CENUMERATION_FEATURE_COUNT = CINTEGRAL_FEATURE_COUNT + 1;

    /**
     * The meta object id for the '
     * {@link com.ibm.etools.c.datatypes.CBoolean <em>CBoolean</em>}' enum.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see com.ibm.etools.c.datatypes.CBoolean
     * @see com.ibm.etools.c.datatypes.impl.DatatypesPackageImpl#getCBoolean()
     * @generated
     */
    int CBOOLEAN = 20;

    /**
     * The meta object id for the '
     * {@link com.ibm.etools.c.datatypes.CDirectionKind <em>CDirection Kind</em>}'
     * enum. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see com.ibm.etools.c.datatypes.CDirectionKind
     * @see com.ibm.etools.c.datatypes.impl.DatatypesPackageImpl#getCDirectionKind()
     * @generated
     */
    int CDIRECTION_KIND = 21;

    /**
     * The meta object id for the '<em>CString</em>' data type. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see java.lang.String
     * @see com.ibm.etools.c.datatypes.impl.DatatypesPackageImpl#getCString()
     * @generated
     */
    int CSTRING = 22;

    /**
     * The meta object id for the '<em>CInteger</em>' data type. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see java.lang.String
     * @see com.ibm.etools.c.datatypes.impl.DatatypesPackageImpl#getCInteger()
     * @generated
     */
    int CINTEGER = 23;

    /**
     * Returns the meta object for class '
     * {@link com.ibm.etools.c.datatypes.CLongDouble <em>CLong Double</em>}'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the meta object for class '<em>CLong Double</em>'.
     * @see com.ibm.etools.c.datatypes.CLongDouble
     * @generated
     */
    EClass getCLongDouble();

    /**
     * Returns the meta object for class '
     * {@link com.ibm.etools.c.datatypes.CFloating <em>CFloating</em>}'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the meta object for class '<em>CFloating</em>'.
     * @see com.ibm.etools.c.datatypes.CFloating
     * @generated
     */
    EClass getCFloating();

    /**
     * Returns the meta object for class '
     * {@link com.ibm.etools.c.datatypes.CFloat <em>CFloat</em>}'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the meta object for class '<em>CFloat</em>'.
     * @see com.ibm.etools.c.datatypes.CFloat
     * @generated
     */
    EClass getCFloat();

    /**
     * Returns the meta object for class '
     * {@link com.ibm.etools.c.datatypes.CUnsignedShort <em>CUnsigned Short</em>}'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the meta object for class '<em>CUnsigned Short</em>'.
     * @see com.ibm.etools.c.datatypes.CUnsignedShort
     * @generated
     */
    EClass getCUnsignedShort();

    /**
     * Returns the meta object for class '
     * {@link com.ibm.etools.c.datatypes.CDouble <em>CDouble</em>}'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the meta object for class '<em>CDouble</em>'.
     * @see com.ibm.etools.c.datatypes.CDouble
     * @generated
     */
    EClass getCDouble();

    /**
     * Returns the meta object for class '
     * {@link com.ibm.etools.c.datatypes.CShort <em>CShort</em>}'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the meta object for class '<em>CShort</em>'.
     * @see com.ibm.etools.c.datatypes.CShort
     * @generated
     */
    EClass getCShort();

    /**
     * Returns the meta object for class '
     * {@link com.ibm.etools.c.datatypes.CUnsignedLongLong <em>CUnsigned Long Long</em>}'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the meta object for class '<em>CUnsigned Long Long</em>'.
     * @see com.ibm.etools.c.datatypes.CUnsignedLongLong
     * @generated
     */
    EClass getCUnsignedLongLong();

    /**
     * Returns the meta object for class '
     * {@link com.ibm.etools.c.datatypes.CLongLong <em>CLong Long</em>}'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the meta object for class '<em>CLong Long</em>'.
     * @see com.ibm.etools.c.datatypes.CLongLong
     * @generated
     */
    EClass getCLongLong();

    /**
     * Returns the meta object for class '
     * {@link com.ibm.etools.c.datatypes.CUnsignedLong <em>CUnsigned Long</em>}'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the meta object for class '<em>CUnsigned Long</em>'.
     * @see com.ibm.etools.c.datatypes.CUnsignedLong
     * @generated
     */
    EClass getCUnsignedLong();

    /**
     * Returns the meta object for class '
     * {@link com.ibm.etools.c.datatypes.CIntegral <em>CIntegral</em>}'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the meta object for class '<em>CIntegral</em>'.
     * @see com.ibm.etools.c.datatypes.CIntegral
     * @generated
     */
    EClass getCIntegral();

    /**
     * Returns the meta object for class '
     * {@link com.ibm.etools.c.datatypes.CLong <em>CLong</em>}'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the meta object for class '<em>CLong</em>'.
     * @see com.ibm.etools.c.datatypes.CLong
     * @generated
     */
    EClass getCLong();

    /**
     * Returns the meta object for class '
     * {@link com.ibm.etools.c.datatypes.CUnsignedChar <em>CUnsigned Char</em>}'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the meta object for class '<em>CUnsigned Char</em>'.
     * @see com.ibm.etools.c.datatypes.CUnsignedChar
     * @generated
     */
    EClass getCUnsignedChar();

    /**
     * Returns the meta object for class '
     * {@link com.ibm.etools.c.datatypes.CChar <em>CChar</em>}'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the meta object for class '<em>CChar</em>'.
     * @see com.ibm.etools.c.datatypes.CChar
     * @generated
     */
    EClass getCChar();

    /**
     * Returns the meta object for class '
     * {@link com.ibm.etools.c.datatypes.CVoid <em>CVoid</em>}'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the meta object for class '<em>CVoid</em>'.
     * @see com.ibm.etools.c.datatypes.CVoid
     * @generated
     */
    EClass getCVoid();

    /**
     * Returns the meta object for class '
     * {@link com.ibm.etools.c.datatypes.CWchar <em>CWchar</em>}'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the meta object for class '<em>CWchar</em>'.
     * @see com.ibm.etools.c.datatypes.CWchar
     * @generated
     */
    EClass getCWchar();

    /**
     * Returns the meta object for class '
     * {@link com.ibm.etools.c.datatypes.CInt <em>CInt</em>}'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the meta object for class '<em>CInt</em>'.
     * @see com.ibm.etools.c.datatypes.CInt
     * @generated
     */
    EClass getCInt();

    /**
     * Returns the meta object for class '
     * {@link com.ibm.etools.c.datatypes.CUnsignedInt <em>CUnsigned Int</em>}'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the meta object for class '<em>CUnsigned Int</em>'.
     * @see com.ibm.etools.c.datatypes.CUnsignedInt
     * @generated
     */
    EClass getCUnsignedInt();

    /**
     * Returns the meta object for class '
     * {@link com.ibm.etools.c.datatypes.CBitField <em>CBit Field</em>}'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the meta object for class '<em>CBit Field</em>'.
     * @see com.ibm.etools.c.datatypes.CBitField
     * @generated
     */
    EClass getCBitField();

    /**
     * Returns the meta object for the attribute '
     * {@link com.ibm.etools.c.datatypes.CBitField#getSize <em>Size</em>}'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the meta object for the attribute '<em>Size</em>'.
     * @see com.ibm.etools.c.datatypes.CBitField#getSize()
     * @see #getCBitField()
     * @generated
     */
    EAttribute getCBitField_Size();

    /**
     * Returns the meta object for the reference '
     * {@link com.ibm.etools.c.datatypes.CBitField#getBaseType <em>Base Type</em>}'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the meta object for the reference '<em>Base Type</em>'.
     * @see com.ibm.etools.c.datatypes.CBitField#getBaseType()
     * @see #getCBitField()
     * @generated
     */
    EReference getCBitField_BaseType();

    /**
     * Returns the meta object for class '
     * {@link com.ibm.etools.c.datatypes.CSignedChar <em>CSigned Char</em>}'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the meta object for class '<em>CSigned Char</em>'.
     * @see com.ibm.etools.c.datatypes.CSignedChar
     * @generated
     */
    EClass getCSignedChar();

    /**
     * Returns the meta object for class '
     * {@link com.ibm.etools.c.datatypes.CEnumeration <em>CEnumeration</em>}'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the meta object for class '<em>CEnumeration</em>'.
     * @see com.ibm.etools.c.datatypes.CEnumeration
     * @generated
     */
    EClass getCEnumeration();

    /**
     * Returns the meta object for the containment reference list '
     * {@link com.ibm.etools.c.datatypes.CEnumeration#getEnumerator <em>Enumerator</em>}'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the meta object for the containment reference list '
     *         <em>Enumerator</em>'.
     * @see com.ibm.etools.c.datatypes.CEnumeration#getEnumerator()
     * @see #getCEnumeration()
     * @generated
     */
    EReference getCEnumeration_Enumerator();

    /**
     * Returns the meta object for enum '
     * {@link com.ibm.etools.c.datatypes.CBoolean <em>CBoolean</em>}'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the meta object for enum '<em>CBoolean</em>'.
     * @see com.ibm.etools.c.datatypes.CBoolean
     * @generated
     */
    EEnum getCBoolean();

    /**
     * Returns the meta object for enum '
     * {@link com.ibm.etools.c.datatypes.CDirectionKind <em>CDirection Kind</em>}'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the meta object for enum '<em>CDirection Kind</em>'.
     * @see com.ibm.etools.c.datatypes.CDirectionKind
     * @generated
     */
    EEnum getCDirectionKind();

    /**
     * Returns the meta object for data type '
     * {@link java.lang.String <em>CString</em>}'. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the meta object for data type '<em>CString</em>'.
     * @see java.lang.String
     * @model instanceClass="java.lang.String"
     * @generated
     */
    EDataType getCString();

    /**
     * Returns the meta object for data type '
     * {@link java.lang.String <em>CInteger</em>}'. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the meta object for data type '<em>CInteger</em>'.
     * @see java.lang.String
     * @model instanceClass="java.lang.String"
     * @generated
     */
    EDataType getCInteger();

    /**
     * Returns the factory that creates the instances of the model. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the factory that creates the instances of the model.
     * @generated
     */
    DatatypesFactory getDatatypesFactory();

} //DatatypesPackage
