/*
 * Licensed Materials - Property of IBM
 *
 * com.ibm.etools.c
 *
 *  Copyright IBM Corporation 2004. All Rights Reserved. 
 *
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */
package com.ibm.etools.c.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;

import com.ibm.etools.c.CClassifier;
import com.ibm.etools.c.CDerived;
import com.ibm.etools.c.CPackage;
import com.ibm.etools.c.CSourceText;
import com.ibm.etools.c.CStructuralFeature;
import com.ibm.etools.c.CStructureContents;
import com.ibm.etools.c.CStructured;
import com.ibm.etools.tdlang.TDLangClassifier;
import com.ibm.etools.tdlang.TDLangPackage;
import com.ibm.etools.typedescriptor.InstanceTDBase;
import com.ibm.etools.typedescriptor.TypeDescriptorPackage;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Structural Feature</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link com.ibm.etools.c.impl.CStructuralFeatureImpl#getContainer <em>Container</em>}
 * </li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public abstract class CStructuralFeatureImpl extends CTypedElementImpl implements CStructuralFeature {
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected CStructuralFeatureImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected EClass eStaticClass() {
        return CPackage.eINSTANCE.getCStructuralFeature();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CStructured getContainer() {
        if (eContainerFeatureID != CPackage.CSTRUCTURAL_FEATURE__CONTAINER)
            return null;
        return (CStructured) eContainer;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setContainer(CStructured newContainer) {
        if (newContainer != eContainer || (eContainerFeatureID != CPackage.CSTRUCTURAL_FEATURE__CONTAINER && newContainer != null)) {
            if (EcoreUtil.isAncestor(this, newContainer))
                throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
            NotificationChain msgs = null;
            if (eContainer != null)
                msgs = eBasicRemoveFromContainer(msgs);
            if (newContainer != null)
                msgs = ((InternalEObject) newContainer).eInverseAdd(this, CPackage.CSTRUCTURED__CONTAINS, CStructured.class, msgs);
            msgs = eBasicSetContainer((InternalEObject) newContainer, CPackage.CSTRUCTURAL_FEATURE__CONTAINER, msgs);
            if (msgs != null)
                msgs.dispatch();
        } else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, CPackage.CSTRUCTURAL_FEATURE__CONTAINER, newContainer, newContainer));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case CPackage.CSTRUCTURAL_FEATURE__TD_LANG_SHARED_TYPE:
                if (tdLangSharedType != null)
                    msgs = ((InternalEObject) tdLangSharedType).eInverseRemove(this, TDLangPackage.TD_LANG_CLASSIFIER__TD_LANG_TYPED_ELEMENT, TDLangClassifier.class, msgs);
                return basicSetTdLangSharedType((TDLangClassifier) otherEnd, msgs);
            case CPackage.CSTRUCTURAL_FEATURE__INSTANCE_TD_BASE:
                if (instanceTDBase != null)
                    msgs = ((InternalEObject) instanceTDBase).eInverseRemove(this, TypeDescriptorPackage.INSTANCE_TD_BASE__LANGUAGE_INSTANCE, InstanceTDBase.class, msgs);
                return basicSetInstanceTDBase((InstanceTDBase) otherEnd, msgs);
            case CPackage.CSTRUCTURAL_FEATURE__CONTAINS:
                if (contains != null)
                    msgs = ((InternalEObject) contains).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - CPackage.CSTRUCTURAL_FEATURE__CONTAINS, null, msgs);
                return basicSetContains((CDerived) otherEnd, msgs);
            case CPackage.CSTRUCTURAL_FEATURE__CONTAINER:
                if (eContainer != null)
                    msgs = eBasicRemoveFromContainer(msgs);
                return eBasicSetContainer(otherEnd, CPackage.CSTRUCTURAL_FEATURE__CONTAINER, msgs);
            default:
                return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
            }
        }
        if (eContainer != null)
            msgs = eBasicRemoveFromContainer(msgs);
        return eBasicSetContainer(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case CPackage.CSTRUCTURAL_FEATURE__TD_LANG_SHARED_TYPE:
                return basicSetTdLangSharedType(null, msgs);
            case CPackage.CSTRUCTURAL_FEATURE__INSTANCE_TD_BASE:
                return basicUnsetInstanceTDBase(msgs);
            case CPackage.CSTRUCTURAL_FEATURE__CONTAINS:
                return basicSetContains(null, msgs);
            case CPackage.CSTRUCTURAL_FEATURE__CONTAINER:
                return eBasicSetContainer(null, CPackage.CSTRUCTURAL_FEATURE__CONTAINER, msgs);
            default:
                return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
            }
        }
        return eBasicSetContainer(null, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
        if (eContainerFeatureID >= 0) {
            switch (eContainerFeatureID) {
            case CPackage.CSTRUCTURAL_FEATURE__CONTAINER:
                return ((InternalEObject) eContainer).eInverseRemove(this, CPackage.CSTRUCTURED__CONTAINS, CStructured.class, msgs);
            default:
                return eDynamicBasicRemoveFromContainer(msgs);
            }
        }
        return ((InternalEObject) eContainer).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Object eGet(EStructuralFeature eFeature, boolean resolve) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CSTRUCTURAL_FEATURE__NAME:
            return getName();
        case CPackage.CSTRUCTURAL_FEATURE__TD_LANG_SHARED_TYPE:
            if (resolve)
                return getTdLangSharedType();
            return basicGetTdLangSharedType();
        case CPackage.CSTRUCTURAL_FEATURE__INSTANCE_TD_BASE:
            if (resolve)
                return getInstanceTDBase();
            return basicGetInstanceTDBase();
        case CPackage.CSTRUCTURAL_FEATURE__TYPE:
            if (resolve)
                return getType();
            return basicGetType();
        case CPackage.CSTRUCTURAL_FEATURE__CONTAINS:
            return getContains();
        case CPackage.CSTRUCTURAL_FEATURE__SOURCE:
            if (resolve)
                return getSource();
            return basicGetSource();
        case CPackage.CSTRUCTURAL_FEATURE__CONTAINER:
            return getContainer();
        }
        return eDynamicGet(eFeature, resolve);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eSet(EStructuralFeature eFeature, Object newValue) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CSTRUCTURAL_FEATURE__NAME:
            setName((String) newValue);
            return;
        case CPackage.CSTRUCTURAL_FEATURE__TD_LANG_SHARED_TYPE:
            setTdLangSharedType((TDLangClassifier) newValue);
            return;
        case CPackage.CSTRUCTURAL_FEATURE__INSTANCE_TD_BASE:
            setInstanceTDBase((InstanceTDBase) newValue);
            return;
        case CPackage.CSTRUCTURAL_FEATURE__TYPE:
            setType((CClassifier) newValue);
            return;
        case CPackage.CSTRUCTURAL_FEATURE__CONTAINS:
            setContains((CDerived) newValue);
            return;
        case CPackage.CSTRUCTURAL_FEATURE__SOURCE:
            setSource((CSourceText) newValue);
            return;
        case CPackage.CSTRUCTURAL_FEATURE__CONTAINER:
            setContainer((CStructured) newValue);
            return;
        }
        eDynamicSet(eFeature, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eUnset(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CSTRUCTURAL_FEATURE__NAME:
            unsetName();
            return;
        case CPackage.CSTRUCTURAL_FEATURE__TD_LANG_SHARED_TYPE:
            setTdLangSharedType((TDLangClassifier) null);
            return;
        case CPackage.CSTRUCTURAL_FEATURE__INSTANCE_TD_BASE:
            unsetInstanceTDBase();
            return;
        case CPackage.CSTRUCTURAL_FEATURE__TYPE:
            setType((CClassifier) null);
            return;
        case CPackage.CSTRUCTURAL_FEATURE__CONTAINS:
            setContains((CDerived) null);
            return;
        case CPackage.CSTRUCTURAL_FEATURE__SOURCE:
            setSource((CSourceText) null);
            return;
        case CPackage.CSTRUCTURAL_FEATURE__CONTAINER:
            setContainer((CStructured) null);
            return;
        }
        eDynamicUnset(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean eIsSet(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CSTRUCTURAL_FEATURE__NAME:
            return isSetName();
        case CPackage.CSTRUCTURAL_FEATURE__TD_LANG_SHARED_TYPE:
            return tdLangSharedType != null;
        case CPackage.CSTRUCTURAL_FEATURE__INSTANCE_TD_BASE:
            return isSetInstanceTDBase();
        case CPackage.CSTRUCTURAL_FEATURE__TYPE:
            return type != null;
        case CPackage.CSTRUCTURAL_FEATURE__CONTAINS:
            return contains != null;
        case CPackage.CSTRUCTURAL_FEATURE__SOURCE:
            return source != null;
        case CPackage.CSTRUCTURAL_FEATURE__CONTAINER:
            return getContainer() != null;
        }
        return eDynamicIsSet(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public int eBaseStructuralFeatureID(int derivedFeatureID, Class baseClass) {
        if (baseClass == CStructureContents.class) {
            switch (derivedFeatureID) {
            case CPackage.CSTRUCTURAL_FEATURE__CONTAINER:
                return CPackage.CSTRUCTURE_CONTENTS__CONTAINER;
            default:
                return -1;
            }
        }
        return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public int eDerivedStructuralFeatureID(int baseFeatureID, Class baseClass) {
        if (baseClass == CStructureContents.class) {
            switch (baseFeatureID) {
            case CPackage.CSTRUCTURE_CONTENTS__CONTAINER:
                return CPackage.CSTRUCTURAL_FEATURE__CONTAINER;
            default:
                return -1;
            }
        }
        return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
    }

} //CStructuralFeatureImpl
