// ****************************************************************
//
//   IBM Confidential
//   OCO Source Materials
//   <<com.ibm.etools.cobol>>
//   (C) Copyright IBM Corp. 2002,2004 - All Rights Reserved.
//   US Government Users Restricted Rights - Use, duplication or disclosure
//   restricted by GSA ADP Schedule Contract with IBM Corp.
//
// ****************************************************************
package com.ibm.etools.cobol.importer;

public interface ICobolPreferenceConstants {

	public static final String copyright = "(c) Copyright IBM Corporation 2001.";
	public String PLUGIN_ID="com.ibm.etools.cobol";

	public String PREFIX = PLUGIN_ID+".";
	public String PRE_COBOL_TRUNC = PREFIX+"COBOL_TRUNC";
	public String PRE_COBOL_NUMPROC = PREFIX+"COBOL_NUMPROC";
	public String PRE_COBOL_NSYMBOL = PREFIX+"COBOL_NSYMBOL";
	public String PRE_COBOL_CODEPAGE = PREFIX+"COBOL_CODEPAGE";
	public String PRE_COBOL_HOST_CODEPAGE_EC = PREFIX+"COBOL_HOST_CODEPAGE_EC";	
	public String PRE_COBOL_FLOATING_POINT_FORMAT = PREFIX+"COBOL_FLOATING_POINT_FORMAT";
	public String PRE_COBOL_ENDIAN = PREFIX+"COBOL_ENDIAN";
	public String PRE_COBOL_REMOTE_ENDIAN = PREFIX+"COBOL_REMOTE_ENDIAN";
	public String PRE_COBOL_EXT_DECIMAL_SIGN = PREFIX+"COBOL_EXT_DECIMAL_SIGN";
	public String PRE_COBOL_QUOTE = PREFIX+"COBOL_QUOTE";
	public String PRE_COBOL_PLATFORM_SELECTION = PREFIX+"COBOL_PLATFORM_SELECTION";
	public String PRE_COBOL_COLLSEQ = PREFIX + "COBOL_COLLSEQ";
	public String PRE_COBOL_NCOLLSEQ = PREFIX + "COBOL_NCOLLSEQ";
	public String PRE_COBOL_CURRENCY = PREFIX + "COBOL_CURRENCY";
	public String PRE_COBOL_SOSI = PREFIX + "COBOL_SOSI";
	public String PRE_COBOL_COMPILE_TIME_LOCALE = PREFIX + "COBOL_COMPILE_TIME_LOCALE";
	public String PRE_COBOL_ASCII_CODEPAGE = PREFIX + "COBOL_ASCII_CODEPAGE";
	public String PRE_COBOL_ERROR_MSGS_LANG = PREFIX + "COBOL_ERROR_MSGS_LANG";
	public String PRE_COBOL_EXTENSION_CBL = PREFIX + "COBOL_EXTENSION_CBL";
	public String PRE_COBOL_EXTENSION_CCP = PREFIX + "COBOL_EXTENSION_CCP";
	public String PRE_COBOL_EXTENSION_COB = PREFIX + "COBOL_EXTENSION_COB";
	public String PRE_COBOL_EXTENSION_CPY = PREFIX + "COBOL_EXTENSION_CPY";	

    public String PLATFORM_WIN = "Win32";
    public String PLATFORM_AIX = "AIX";
    public String PLATFORM_ZOS = "z/OS";
    public String PLATFORM_NONE = "Not Specified";
	public int DEFAULT_PS = 0;
	public int DEFAULT_COMPILE_TIME_LOCALE = 0;
	public int DEFAULT_ASCII_CODEPAGE = 0;
	public int DEFAULT_ERROR_MSGS_LANG = 0;
	public String DEFAULT_CURRENCY = "\"$\"";
	
	public String DEFAULT_CODEPAGE = "ISO-8859-1";
	public String OS_CODEPAGE = "IBM-037";
	
	public String FLOAT_IEEE = "IEEE Non-Extended";
	public String FLOAT_IBM390 = "IBM 390 Hexadecimal";
	public int DEFAULT_FPT = 0;
	public int OS_FPT = 1;
	
	public String NUMPROC_PFD = "PFD";
	
	public String ENDIAN_LITTLE = "Little";
	public String ENDIAN_BIG = "Big";
	
	public String DECIMAL_ASCII = "ASCII";
	public String DECIMAL_EBCDIC = "EBCDIC";
	public String DECIMAL_EBCDICC = "EBCDIC Custom";
	
	public String QUOTE_DOUBLE = "DOUBLE";
	public String QUOTE_SINGLE = "SINGLE";
	
	public String TRUNC_STD = "STD";
	public String TRUNC_OPT = "OPT";
	public String TRUNC_BIN = "BIN";
	
	public String NSYMBOL_DBCS = "DBCS";
	public String NSYMBOL_NATIONAL = "NATIONAL";

	public String COLLSEQ_LOCALE = "LOCALE";
	public String COLLSEQ_EBCDIC = "EBCDIC";
	public String COLLSEQ_BIN = "BIN";
	
	public String NCOLLSEQ_LOCALE = "LOCALE";
	public String NCOLLSEQ_BIN = "BIN";
	
	public String DEFAULT_ES = "FP";
	public String NOT_DEFAULT_ES = "DS";
	
			
}

